------------------------------------------------------------------------------
--                                                                          --
--                        ADACOM BINDING COMPONENTS                         --
--                                                                          --
--                               A D A C O M                                --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                            $Revision: 1.1.1.1 $                              --
--                                                                          --
--                   Copyright (C) 1999 David Botton                        --
--                                                                          --
-- This is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. It is distributed in the hope that it will be useful, but WITHOUT  --
-- ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY or  --
-- FITNESS FOR A PARTICULAR PURPOSE.    See the GNU General Public License  --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with this;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
-- ADACOM is maintained by David Botton (http://www.botton.com/ada).        --
--                                                                          --
------------------------------------------------------------------------------

-- AdaCom is a collection of packages for use in interfacing Ada with Type
-- Libraries, COM/DCOM Objects, and OLE

with Win32.Rpcdce;
with Interfaces.C;
with Stdole;
with System;

package AdaCom is

   function To_GUID(GUID : String) return Stdole.GUID;
   -- Converts a string with a GUID in registry format to a GUID

   function To_String(GUID : Stdole.GUID) return String;
   -- Converts a GUID to a string in registry format

   function Format_GUID (guid : Win32.Rpcdce.GUID) return String;
   -- Formats a GUID in to a String using the standard GUID format

   function CLSID_From_PROGID (PROGID : String) return Stdole.GUID;
   -- Creates a CLSID from a PROGID

   Invalid_PROGID_Error : exception;
   -- raised if unable to create CLSID from a PROGID

   GUID_Conversion_Error : exception;
   -- Raised if there is a problem convertion String <-> GUID
end AdaCom;



