with win32.objbase; use win32.objbase;
with interfaces.c; use interfaces.c;

package Beep_Global is

   -- Global variables for COM to determine when to unload
   g_cComponents : aliased long :=0;
   g_cServer     : aliased long :=0;

   -- This is set to false by the local server (exe) version of the COM object
   -- telling the COM object to close down the local server if all instances
   -- of the COM object are released.
   InProcServer  : Boolean := True;

   -- Type library ID for our COM Object
   LIBID_BeepLibrary : aliased IID := (16#0FE0EE20#,16#8AA2#,16#11d2#,
                        (Char'Val(16#81#),Char'Val(16#AA#),Char'Val(16#44#),
                         Char'Val(16#45#),Char'Val(16#53#),Char'Val(16#54#),
                         Char'Val(16#00#),Char'Val(16#01#)) );

   -- Class ID of COM object to be created
   CLSID_BeepClass   : aliased CLSID := (16#0FE0EE21#,16#8AA2#,16#11d2#,
                        (Char'Val(16#81#),Char'Val(16#AA#),Char'Val(16#44#),
                         Char'Val(16#45#),Char'Val(16#53#),Char'Val(16#54#),
                         Char'Val(16#00#),Char'Val(16#01#)) );

   -- IID for IBeep
   IID_IBeep         : aliased IID := (16#0FE0EE22#,16#8AA2#,16#11d2#,
                        (Char'Val(16#81#),Char'Val(16#AA#),Char'Val(16#44#),
                         Char'Val(16#45#),Char'Val(16#53#),Char'Val(16#54#),
                         Char'Val(16#00#),Char'Val(16#01#)) );

   -- IID for IMessage
   IID_IMessage      : aliased IID := (16#0FE0EE23#,16#8AA2#,16#11d2#,
                        (Char'Val(16#81#),Char'Val(16#AA#),Char'Val(16#44#),
                         Char'Val(16#45#),Char'Val(16#53#),Char'Val(16#54#),
                         Char'Val(16#00#),Char'Val(16#01#)) );

   -- IID for IMessage
   IID_IStat        : aliased IID := (16#0FE0EE24#,16#8AA2#,16#11d2#,
                        (Char'Val(16#81#),Char'Val(16#AA#),Char'Val(16#44#),
                         Char'Val(16#45#),Char'Val(16#53#),Char'Val(16#54#),
                         Char'Val(16#00#),Char'Val(16#01#)) );

   -- IID for IUnkown
   IID_IUnknown      : aliased IID := (16#00000000#,16#0000#,16#0000#,
                        (Char'Val(16#C0#),Char'Val(16#00#),
                         Char'Val(16#00#),Char'Val(16#00#),
                         Char'Val(16#00#),Char'Val(16#00#),
                         Char'Val(16#00#),Char'Val(16#46#)) );

   -- IID for IUnkown
   IID_IClassFactory : aliased IID := (16#00000001#,16#0000#,16#0000#,
                        (Char'Val(16#C0#),Char'Val(16#00#),
                         Char'Val(16#00#),Char'Val(16#00#),
                         Char'Val(16#00#),Char'Val(16#00#),
                         Char'Val(16#00#),Char'Val(16#46#)) );

   procedure Can_Close;
   -- Can_Close is called when any object is released in order to allow
   -- the local server version of the COM object to post a WM_QUIT message
   -- to the server when needed.
   -- If there is no plans to build a local server version, Can_Close
   -- and calls to Can_Close can be removed from the code.

end Beep_Global;

