with win32.windef;

with win32.objbase; use win32.objbase;
with interfaces.c; use interfaces.c;

package BeepDll is

   pragma Linker_Options ("oleaut32.lib");
   -- Link in OLE Automation libraries

   pragma Linker_Options ("beeprc.rbj");
   -- Link in resource file that has the COM object's type library

   function DllGetClassObject (clsid : REFCLSID;
                               riid  : REFIID;
                               ppv   : access Win32.PVOID)
                               return unsigned_long;
   pragma Export (Stdcall, DllGetClassObject, "DllGetClassObject");
   -- Used to expose the Class Factory Object's IClassFactory interface to
   -- the SCM that can create objects of the CLSID riid. The SCM (a part of
   -- the OS) then delivers this interface through proxies were needed to
   -- the client application or to the Win32 API function CoCreateInstance

   function DllCanUnloadNow return unsigned_long;
   pragma Export(Stdcall, DllCanUnloadNow, "DllCanUnloadNow");
   -- This is called by the OS to determine if the Dll can be unloaded.
   -- This returns true if there are no instance of the COM object in use
   -- and there are no locks placed on the server through
   -- IClassFactory::LockServer

   function DllRegisterServer return unsigned_long;
   pragma Export(Stdcall, DllRegisterServer, "DllRegisterServer");
   -- Is called by RegSvr32 (or other application) to request the DLL to
   -- register its COM objects in the registry

   function DllUnregisterServer return unsigned_long;
   pragma Export(Stdcall, DllUnregisterServer, "DllUnregisterServer");
   -- Is called by RegSvr32 (or other application) to request the DLL to
   -- unregister its COM objects from the registry.

   hInstance : Win32.Windef.HINSTANCE;
   -- Contains the intstance handle of the DLL once loaded.

end BeepDll;
