-- Library Name             : stdole
-- Library Documentation    : OLE Automation
-- Library Version          : 2.0

with Interfaces.C; use Interfaces.C;
with Win32.OleAuto;
with System;

package stdole is

   type HRESULT is new Interfaces.C.Unsigned_Long;

   subtype SCODE is HRESULT;

   subtype PVOID is System.Address;

   S_OK : constant := 0;

   -- Element Name             : GUID
   -- Element Kind             : Record
      type GUID_Data4_Array is array (Integer range  0 .. 7) of Interfaces.C.unsigned_char;
   type GUID is record
      Data1 : Interfaces.C.unsigned_long;
      Data2 : Interfaces.C.unsigned_short;
      Data3 : Interfaces.C.unsigned_short;
      Data4 : GUID_Data4_Array;
   end record;

   -- {00020430-0000-0000-C000-000000000046}
   LIBID_stdole : aliased Stdole.GUID := ( 132144 , 0 , 0 ,
      (unsigned_char'Val( 192),unsigned_char'Val( 0),unsigned_char'Val( 0),
       unsigned_char'Val( 0),unsigned_char'Val( 0),unsigned_char'Val( 0),
       unsigned_char'Val( 0),unsigned_char'Val( 70)));

   -- Element Name             : DISPPARAMS
   -- Element Kind             : Record
      type DISPPARAMS_rgvarg_Pointer is access all Win32.OleAuto.VARIANT;
      type DISPPARAMS_rgdispidNamedArgs_Pointer is access all Interfaces.C.long;
   type DISPPARAMS is record
      rgvarg : DISPPARAMS_rgvarg_Pointer;
      rgdispidNamedArgs : DISPPARAMS_rgdispidNamedArgs_Pointer;
      cArgs : Interfaces.C.unsigned;
      cNamedArgs : Interfaces.C.unsigned;
   end record;

   -- Element Name             : EXCEPINFO
   -- Element Kind             : Record
   type EXCEPINFO is record
      wCode : Interfaces.C.unsigned_short;
      wReserved : Interfaces.C.unsigned_short;
      bstrSource : Win32.OleAuto.BSTR;
      bstrDescription : Win32.OleAuto.BSTR;
      bstrHelpFile : Win32.OleAuto.BSTR;
      dwHelpContext : Interfaces.C.unsigned_long;
      pvReserved : PVOID;
      pfnDeferredFillIn : PVOID;
      scode : Stdole.SCODE;
   end record;

   -- Element Name             : IUnknown
   -- Element Kind             : Interface
   -- {00000000-0000-0000-C000-000000000046}
   IID_IUnknown : aliased Stdole.GUID := ( 0 , 0 , 0 ,
      (unsigned_char'Val( 192),unsigned_char'Val( 0),unsigned_char'Val( 0),
       unsigned_char'Val( 0),unsigned_char'Val( 0),unsigned_char'Val( 0),
       unsigned_char'Val( 0),unsigned_char'Val( 70)));

   type IUnknown;
   type Pointer_To_IUnknown is access all IUnknown;
   type IUnknownVtbl;
   type Pointer_To_IUnknownVtbl is access all IUnknownVtbl;

   type af_IUnknown_QueryInterface is access function (
      This : access IUnknown;
      riid : access GUID;
      ppvObj : access PVOID
      ) return HRESULT;

   pragma Convention(StdCall, af_IUnknown_QueryInterface);

   type af_IUnknown_AddRef is access function (
      This : access IUnknown
      ) return Interfaces.C.unsigned_long;

   pragma Convention(StdCall, af_IUnknown_AddRef);

   type af_IUnknown_Release is access function (
      This : access IUnknown
      ) return Interfaces.C.unsigned_long;

   pragma Convention(StdCall, af_IUnknown_Release);

   type IUnknown is record
      lpVtbl : Pointer_To_IUnknownVtbl;
   end record;
   pragma Convention(C_Pass_By_Copy, IUnknown);

   type IUnknownVtbl is record
      QueryInterface : af_IUnknown_QueryInterface;
      AddRef : af_IUnknown_AddRef;
      Release : af_IUnknown_Release;
   end record;
   pragma Convention(C_Pass_By_Copy, IUnknownVtbl);

   -- Element Name             : IDispatch
   -- Element Kind             : Interface
   -- {00020400-0000-0000-C000-000000000046}
   IID_IDispatch : aliased Stdole.GUID := ( 132096 , 0 , 0 ,
      (unsigned_char'Val( 192),unsigned_char'Val( 0),unsigned_char'Val( 0),
       unsigned_char'Val( 0),unsigned_char'Val( 0),unsigned_char'Val( 0),
       unsigned_char'Val( 0),unsigned_char'Val( 70)));

   type IDispatch;
   type Pointer_To_IDispatch is access all IDispatch;
   type IDispatchVtbl;
   type Pointer_To_IDispatchVtbl is access all IDispatchVtbl;

   -- From Parent IUnknown
   type af_IDispatch_QueryInterface is access function (
      This : access IDispatch;
      riid : access GUID;
      ppvObj : access PVOID
      ) return HRESULT;

   pragma Convention(StdCall, af_IDispatch_QueryInterface);

   -- From Parent IUnknown
   type af_IDispatch_AddRef is access function (
      This : access IDispatch
      ) return Interfaces.C.unsigned_long;

   pragma Convention(StdCall, af_IDispatch_AddRef);

   -- From Parent IUnknown
   type af_IDispatch_Release is access function (
      This : access IDispatch
      ) return Interfaces.C.unsigned_long;

   pragma Convention(StdCall, af_IDispatch_Release);

   type af_IDispatch_GetTypeInfoCount is access function (
      This : access IDispatch;
      pctinfo : access Interfaces.C.unsigned
      ) return HRESULT;

   pragma Convention(StdCall, af_IDispatch_GetTypeInfoCount);

   type af_IDispatch_GetTypeInfo is access function (
      This : access IDispatch;
      itinfo : Interfaces.C.unsigned;
      lcid : Interfaces.C.unsigned_long;
      pptinfo : access PVOID
      ) return HRESULT;

   pragma Convention(StdCall, af_IDispatch_GetTypeInfo);

      type af_IDispatch_GetIDsOfNames_scode_Pointer is access all Interfaces.C.char;
   type af_IDispatch_GetIDsOfNames is access function (
      This : access IDispatch;
      riid : access GUID;
      rgszNames : access af_IDispatch_GetIDsOfNames_scode_Pointer;
      cNames : Interfaces.C.unsigned;
      lcid : Interfaces.C.unsigned_long;
      rgdispid : access Interfaces.C.long
      ) return HRESULT;

   pragma Convention(StdCall, af_IDispatch_GetIDsOfNames);

   type af_IDispatch_Invoke is access function (
      This : access IDispatch;
      dispidMember : Interfaces.C.long;
      riid : access GUID;
      lcid : Interfaces.C.unsigned_long;
      wFlags : Interfaces.C.unsigned_short;
      pdispparams : access DISPPARAMS;
      pvarResult : access Win32.OleAuto.VARIANT;
      pexcepinfo : access EXCEPINFO;
      puArgErr : access Interfaces.C.unsigned
      ) return HRESULT;

   pragma Convention(StdCall, af_IDispatch_Invoke);

   type IDispatch is record
      lpVtbl : Pointer_To_IDispatchVtbl;
   end record;
   pragma Convention(C_Pass_By_Copy, IDispatch);

   type IDispatchVtbl is record
      -- From Parent IUnknown
      QueryInterface : af_IDispatch_QueryInterface;
      -- From Parent IUnknown
      AddRef : af_IDispatch_AddRef;
      -- From Parent IUnknown
      Release : af_IDispatch_Release;
      GetTypeInfoCount : af_IDispatch_GetTypeInfoCount;
      GetTypeInfo : af_IDispatch_GetTypeInfo;
      GetIDsOfNames : af_IDispatch_GetIDsOfNames;
      Invoke : af_IDispatch_Invoke;
   end record;
   pragma Convention(C_Pass_By_Copy, IDispatchVtbl);

   -- Element Name             : IEnumVARIANT
   -- Element Kind             : Interface
   -- {00020404-0000-0000-C000-000000000046}
   IID_IEnumVARIANT : aliased Stdole.GUID := ( 132100 , 0 , 0 ,
      (unsigned_char'Val( 192),unsigned_char'Val( 0),unsigned_char'Val( 0),
       unsigned_char'Val( 0),unsigned_char'Val( 0),unsigned_char'Val( 0),
       unsigned_char'Val( 0),unsigned_char'Val( 70)));

   type IEnumVARIANT;
   type Pointer_To_IEnumVARIANT is access all IEnumVARIANT;
   type IEnumVARIANTVtbl;
   type Pointer_To_IEnumVARIANTVtbl is access all IEnumVARIANTVtbl;

   -- From Parent IUnknown
   type af_IEnumVARIANT_QueryInterface is access function (
      This : access IEnumVARIANT;
      riid : access GUID;
      ppvObj : access PVOID
      ) return HRESULT;

   pragma Convention(StdCall, af_IEnumVARIANT_QueryInterface);

   -- From Parent IUnknown
   type af_IEnumVARIANT_AddRef is access function (
      This : access IEnumVARIANT
      ) return Interfaces.C.unsigned_long;

   pragma Convention(StdCall, af_IEnumVARIANT_AddRef);

   -- From Parent IUnknown
   type af_IEnumVARIANT_Release is access function (
      This : access IEnumVARIANT
      ) return Interfaces.C.unsigned_long;

   pragma Convention(StdCall, af_IEnumVARIANT_Release);

   type af_IEnumVARIANT_Next is access function (
      This : access IEnumVARIANT;
      celt : Interfaces.C.unsigned_long;
      rgvar : access Win32.OleAuto.VARIANT;
      pceltFetched : access Interfaces.C.unsigned_long
      ) return HRESULT;

   pragma Convention(StdCall, af_IEnumVARIANT_Next);

   type af_IEnumVARIANT_Skip is access function (
      This : access IEnumVARIANT;
      celt : Interfaces.C.unsigned_long
      ) return HRESULT;

   pragma Convention(StdCall, af_IEnumVARIANT_Skip);

   type af_IEnumVARIANT_Reset is access function (
      This : access IEnumVARIANT
      ) return HRESULT;

   pragma Convention(StdCall, af_IEnumVARIANT_Reset);

      type af_IEnumVARIANT_Clone_scode_Pointer is access all IEnumVARIANT;
   type af_IEnumVARIANT_Clone is access function (
      This : access IEnumVARIANT;
      ppenum : access af_IEnumVARIANT_Clone_scode_Pointer
      ) return HRESULT;

   pragma Convention(StdCall, af_IEnumVARIANT_Clone);

   type IEnumVARIANT is record
      lpVtbl : Pointer_To_IEnumVARIANTVtbl;
   end record;
   pragma Convention(C_Pass_By_Copy, IEnumVARIANT);

   type IEnumVARIANTVtbl is record
      -- From Parent IUnknown
      QueryInterface : af_IEnumVARIANT_QueryInterface;
      -- From Parent IUnknown
      AddRef : af_IEnumVARIANT_AddRef;
      -- From Parent IUnknown
      Release : af_IEnumVARIANT_Release;
      Next : af_IEnumVARIANT_Next;
      Skip : af_IEnumVARIANT_Skip;
      Reset : af_IEnumVARIANT_Reset;
      Clone : af_IEnumVARIANT_Clone;
   end record;
   pragma Convention(C_Pass_By_Copy, IEnumVARIANTVtbl);

   -- Element Name             : OLE_COLOR
   -- Element Kind             : Alias
   subtype OLE_COLOR is Interfaces.C.unsigned_long;

   -- Element Name             : OLE_XPOS_PIXELS
   -- Element Kind             : Alias
   subtype OLE_XPOS_PIXELS is Interfaces.C.long;

   -- Element Name             : OLE_YPOS_PIXELS
   -- Element Kind             : Alias
   subtype OLE_YPOS_PIXELS is Interfaces.C.long;

   -- Element Name             : OLE_XSIZE_PIXELS
   -- Element Kind             : Alias
   subtype OLE_XSIZE_PIXELS is Interfaces.C.long;

   -- Element Name             : OLE_YSIZE_PIXELS
   -- Element Kind             : Alias
   subtype OLE_YSIZE_PIXELS is Interfaces.C.long;

   -- Element Name             : OLE_XPOS_HIMETRIC
   -- Element Kind             : Alias
   subtype OLE_XPOS_HIMETRIC is Interfaces.C.long;

   -- Element Name             : OLE_YPOS_HIMETRIC
   -- Element Kind             : Alias
   subtype OLE_YPOS_HIMETRIC is Interfaces.C.long;

   -- Element Name             : OLE_XSIZE_HIMETRIC
   -- Element Kind             : Alias
   subtype OLE_XSIZE_HIMETRIC is Interfaces.C.long;

   -- Element Name             : OLE_YSIZE_HIMETRIC
   -- Element Kind             : Alias
   subtype OLE_YSIZE_HIMETRIC is Interfaces.C.long;

   -- Element Name             : OLE_XPOS_CONTAINER
   -- Element Kind             : Alias
   subtype OLE_XPOS_CONTAINER is C_float;

   -- Element Name             : OLE_YPOS_CONTAINER
   -- Element Kind             : Alias
   subtype OLE_YPOS_CONTAINER is C_float;

   -- Element Name             : OLE_XSIZE_CONTAINER
   -- Element Kind             : Alias
   subtype OLE_XSIZE_CONTAINER is C_float;

   -- Element Name             : OLE_YSIZE_CONTAINER
   -- Element Kind             : Alias
   subtype OLE_YSIZE_CONTAINER is C_float;

   -- Element Name             : OLE_HANDLE
   -- Element Kind             : Alias
   subtype OLE_HANDLE is Interfaces.C.int;

   -- Element Name             : OLE_OPTEXCLUSIVE
   -- Element Kind             : Alias
   subtype OLE_OPTEXCLUSIVE is Win32.OleAuto.VARIANT_BOOL;

   -- Element Name             : OLE_CANCELBOOL
   -- Element Kind             : Alias
   subtype OLE_CANCELBOOL is Win32.OleAuto.VARIANT_BOOL;

   -- Element Name             : OLE_ENABLEDEFAULTBOOL
   -- Element Kind             : Alias
   subtype OLE_ENABLEDEFAULTBOOL is Win32.OleAuto.VARIANT_BOOL;

   -- Element Name             : OLE_TRISTATE
   -- Element Kind             : Enumeration
   type OLE_TRISTATE is new Interfaces.C.long;

   Unchecked : constant := 0;
   Checked : constant := 1;
   Gray : constant := 2;

   -- Element Name             : FONTNAME
   -- Element Kind             : Alias
   subtype FONTNAME is Win32.OleAuto.BSTR;

   -- Element Name             : FONTSIZE
   -- Element Kind             : Alias
   subtype FONTSIZE is Win32.OleAuto.CURRENCY;

   -- Element Name             : FONTBOLD
   -- Element Kind             : Alias
   subtype FONTBOLD is Win32.OleAuto.VARIANT_BOOL;

   -- Element Name             : FONTITALIC
   -- Element Kind             : Alias
   subtype FONTITALIC is Win32.OleAuto.VARIANT_BOOL;

   -- Element Name             : FONTUNDERSCORE
   -- Element Kind             : Alias
   subtype FONTUNDERSCORE is Win32.OleAuto.VARIANT_BOOL;

   -- Element Name             : FONTSTRIKETHROUGH
   -- Element Kind             : Alias
   subtype FONTSTRIKETHROUGH is Win32.OleAuto.VARIANT_BOOL;

   -- Element Name             : IFont
   -- Element Documentation    : Font Object
   -- Element Kind             : Interface
   -- {BEF6E002-A874-101A-8BBA-00AA00300CAB}
   IID_IFont : aliased Stdole.GUID := ( 3203850242 , 43124 , 4122 ,
      (unsigned_char'Val( 139),unsigned_char'Val( 186),unsigned_char'Val( 0),
       unsigned_char'Val( 170),unsigned_char'Val( 0),unsigned_char'Val( 48),
       unsigned_char'Val( 12),unsigned_char'Val( 171)));

   type IFont;
   type Pointer_To_IFont is access all IFont;
   type IFontVtbl;
   type Pointer_To_IFontVtbl is access all IFontVtbl;

   -- From Parent IUnknown
   type af_IFont_QueryInterface is access function (
      This : access IFont;
      riid : access GUID;
      ppvObj : access PVOID
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_QueryInterface);

   -- From Parent IUnknown
   type af_IFont_AddRef is access function (
      This : access IFont
      ) return Interfaces.C.unsigned_long;

   pragma Convention(StdCall, af_IFont_AddRef);

   -- From Parent IUnknown
   type af_IFont_Release is access function (
      This : access IFont
      ) return Interfaces.C.unsigned_long;

   pragma Convention(StdCall, af_IFont_Release);

   type af_IFont_Get_Name is access function (
      This : access IFont;
      pname : access Win32.OleAuto.BSTR
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Get_Name);

   type af_IFont_Put_Name is access function (
      This : access IFont;
      Value : Win32.OleAuto.BSTR
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Put_Name);

   type af_IFont_Get_Size is access function (
      This : access IFont;
      psize : access Win32.OleAuto.CURRENCY
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Get_Size);

   type af_IFont_Put_Size is access function (
      This : access IFont;
      Value : Win32.OleAuto.CURRENCY
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Put_Size);

   type af_IFont_Get_Bold is access function (
      This : access IFont;
      pbold : access Win32.OleAuto.VARIANT_BOOL
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Get_Bold);

   type af_IFont_Put_Bold is access function (
      This : access IFont;
      Value : Win32.OleAuto.VARIANT_BOOL
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Put_Bold);

   type af_IFont_Get_Italic is access function (
      This : access IFont;
      pitalic : access Win32.OleAuto.VARIANT_BOOL
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Get_Italic);

   type af_IFont_Put_Italic is access function (
      This : access IFont;
      Value : Win32.OleAuto.VARIANT_BOOL
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Put_Italic);

   type af_IFont_Get_Underline is access function (
      This : access IFont;
      punderline : access Win32.OleAuto.VARIANT_BOOL
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Get_Underline);

   type af_IFont_Put_Underline is access function (
      This : access IFont;
      Value : Win32.OleAuto.VARIANT_BOOL
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Put_Underline);

   type af_IFont_Get_Strikethrough is access function (
      This : access IFont;
      pstrikethrough : access Win32.OleAuto.VARIANT_BOOL
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Get_Strikethrough);

   type af_IFont_Put_Strikethrough is access function (
      This : access IFont;
      Value : Win32.OleAuto.VARIANT_BOOL
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Put_Strikethrough);

   type af_IFont_Get_Weight is access function (
      This : access IFont;
      pweight : access Interfaces.C.short
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Get_Weight);

   type af_IFont_Put_Weight is access function (
      This : access IFont;
      Value : Interfaces.C.short
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Put_Weight);

   type af_IFont_Get_Charset is access function (
      This : access IFont;
      pcharset : access Interfaces.C.short
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Get_Charset);

   type af_IFont_Put_Charset is access function (
      This : access IFont;
      Value : Interfaces.C.short
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Put_Charset);

   type af_IFont_Get_hFont is access function (
      This : access IFont;
      phfont : access OLE_HANDLE
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Get_hFont);

      type af_IFont_Clone_scode_Pointer is access all IFont;
   type af_IFont_Clone is access function (
      This : access IFont;
      ppfont : access af_IFont_Clone_scode_Pointer
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_Clone);

   type af_IFont_IsEqual is access function (
      This : access IFont;
      pfontOther : access IFont
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_IsEqual);

   type af_IFont_SetRatio is access function (
      This : access IFont;
      cyLogical : Interfaces.C.long;
      cyHimetric : Interfaces.C.long
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_SetRatio);

   type af_IFont_AddRefHfont is access function (
      This : access IFont;
      hFont : OLE_HANDLE
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_AddRefHfont);

   type af_IFont_ReleaseHfont is access function (
      This : access IFont;
      hFont : OLE_HANDLE
      ) return HRESULT;

   pragma Convention(StdCall, af_IFont_ReleaseHfont);

   type IFont is record
      lpVtbl : Pointer_To_IFontVtbl;
   end record;
   pragma Convention(C_Pass_By_Copy, IFont);

   type IFontVtbl is record
      -- From Parent IUnknown
      QueryInterface : af_IFont_QueryInterface;
      -- From Parent IUnknown
      AddRef : af_IFont_AddRef;
      -- From Parent IUnknown
      Release : af_IFont_Release;
      Get_Name : af_IFont_Get_Name;
      Put_Name : af_IFont_Put_Name;
      Get_Size : af_IFont_Get_Size;
      Put_Size : af_IFont_Put_Size;
      Get_Bold : af_IFont_Get_Bold;
      Put_Bold : af_IFont_Put_Bold;
      Get_Italic : af_IFont_Get_Italic;
      Put_Italic : af_IFont_Put_Italic;
      Get_Underline : af_IFont_Get_Underline;
      Put_Underline : af_IFont_Put_Underline;
      Get_Strikethrough : af_IFont_Get_Strikethrough;
      Put_Strikethrough : af_IFont_Put_Strikethrough;
      Get_Weight : af_IFont_Get_Weight;
      Put_Weight : af_IFont_Put_Weight;
      Get_Charset : af_IFont_Get_Charset;
      Put_Charset : af_IFont_Put_Charset;
      Get_hFont : af_IFont_Get_hFont;
      Clone : af_IFont_Clone;
      IsEqual : af_IFont_IsEqual;
      SetRatio : af_IFont_SetRatio;
      AddRefHfont : af_IFont_AddRefHfont;
      ReleaseHfont : af_IFont_ReleaseHfont;
   end record;
   pragma Convention(C_Pass_By_Copy, IFontVtbl);

   -- Element Name             : Font
   -- Element Kind             : Dispatch
   subtype Font is IDispatch;

   -- Element Name             : IFontDisp
   -- Element Kind             : Alias
   subtype IFontDisp is Font;

   -- Element Name             : StdFont
   -- Element Kind             : CoClass
   -- {0BE35203-8F91-11CE-9DE3-00AA004BB851}
   CLSID_StdFont : aliased Stdole.GUID := ( 199447043 , 36753 , 4558 ,
      (unsigned_char'Val( 157),unsigned_char'Val( 227),unsigned_char'Val( 0),
       unsigned_char'Val( 170),unsigned_char'Val( 0),unsigned_char'Val( 75),
       unsigned_char'Val( 184),unsigned_char'Val( 81)));

   -- Element Name             : IPicture
   -- Element Documentation    : Picture Object
   -- Element Kind             : Interface
   -- {7BF80980-BF32-101A-8BBB-00AA00300CAB}
   IID_IPicture : aliased Stdole.GUID := ( 2079852928 , 48946 , 4122 ,
      (unsigned_char'Val( 139),unsigned_char'Val( 187),unsigned_char'Val( 0),
       unsigned_char'Val( 170),unsigned_char'Val( 0),unsigned_char'Val( 48),
       unsigned_char'Val( 12),unsigned_char'Val( 171)));

   type IPicture;
   type Pointer_To_IPicture is access all IPicture;
   type IPictureVtbl;
   type Pointer_To_IPictureVtbl is access all IPictureVtbl;

   -- From Parent IUnknown
   type af_IPicture_QueryInterface is access function (
      This : access IPicture;
      riid : access GUID;
      ppvObj : access PVOID
      ) return HRESULT;

   pragma Convention(StdCall, af_IPicture_QueryInterface);

   -- From Parent IUnknown
   type af_IPicture_AddRef is access function (
      This : access IPicture
      ) return Interfaces.C.unsigned_long;

   pragma Convention(StdCall, af_IPicture_AddRef);

   -- From Parent IUnknown
   type af_IPicture_Release is access function (
      This : access IPicture
      ) return Interfaces.C.unsigned_long;

   pragma Convention(StdCall, af_IPicture_Release);

   type af_IPicture_Get_Handle is access function (
      This : access IPicture;
      phandle : access OLE_HANDLE
      ) return HRESULT;

   pragma Convention(StdCall, af_IPicture_Get_Handle);

   type af_IPicture_Get_hPal is access function (
      This : access IPicture;
      phpal : access OLE_HANDLE
      ) return HRESULT;

   pragma Convention(StdCall, af_IPicture_Get_hPal);

   type af_IPicture_Get_Type is access function (
      This : access IPicture;
      ptype : access Interfaces.C.short
      ) return HRESULT;

   pragma Convention(StdCall, af_IPicture_Get_Type);

   type af_IPicture_Get_Width is access function (
      This : access IPicture;
      pwidth : access OLE_XSIZE_HIMETRIC
      ) return HRESULT;

   pragma Convention(StdCall, af_IPicture_Get_Width);

   type af_IPicture_Get_Height is access function (
      This : access IPicture;
      pheight : access OLE_YSIZE_HIMETRIC
      ) return HRESULT;

   pragma Convention(StdCall, af_IPicture_Get_Height);

   type af_IPicture_Render is access function (
      This : access IPicture;
      hdc : Interfaces.C.int;
      x : Interfaces.C.long;
      y : Interfaces.C.long;
      cx : Interfaces.C.long;
      cy : Interfaces.C.long;
      xSrc : OLE_XPOS_HIMETRIC;
      ySrc : OLE_YPOS_HIMETRIC;
      cxSrc : OLE_XSIZE_HIMETRIC;
      cySrc : OLE_YSIZE_HIMETRIC;
      prcWBounds : Win32.PVOID
      ) return HRESULT;

   pragma Convention(StdCall, af_IPicture_Render);

   type af_IPicture_Put_hPal is access function (
      This : access IPicture;
      Value : OLE_HANDLE
      ) return HRESULT;

   pragma Convention(StdCall, af_IPicture_Put_hPal);

   type af_IPicture_Get_CurDC is access function (
      This : access IPicture;
      phdcOut : access Interfaces.C.int
      ) return HRESULT;

   pragma Convention(StdCall, af_IPicture_Get_CurDC);

   type af_IPicture_SelectPicture is access function (
      This : access IPicture;
      hdcIn : Interfaces.C.int;
      phdcOut : access Interfaces.C.int;
      phbmpOut : access OLE_HANDLE
      ) return HRESULT;

   pragma Convention(StdCall, af_IPicture_SelectPicture);

   type af_IPicture_Get_KeepOriginalFormat is access function (
      This : access IPicture;
      pfkeep : access Win32.OleAuto.VARIANT_BOOL
      ) return HRESULT;

   pragma Convention(StdCall, af_IPicture_Get_KeepOriginalFormat);

   type af_IPicture_Put_KeepOriginalFormat is access function (
      This : access IPicture;
      Value : Win32.OleAuto.VARIANT_BOOL
      ) return HRESULT;

   pragma Convention(StdCall, af_IPicture_Put_KeepOriginalFormat);

   type af_IPicture_PictureChanged is access function (
      This : access IPicture
      ) return HRESULT;

   pragma Convention(StdCall, af_IPicture_PictureChanged);

   type af_IPicture_SaveAsFile is access function (
      This : access IPicture;
      pstm : Win32.PVOID;
      fSaveMemCopy : Win32.OleAuto.VARIANT_BOOL;
      pcbSize : access Interfaces.C.long
      ) return HRESULT;

   pragma Convention(StdCall, af_IPicture_SaveAsFile);

   type af_IPicture_Get_Attributes is access function (
      This : access IPicture;
      pdwAttr : access Interfaces.C.long
      ) return HRESULT;

   pragma Convention(StdCall, af_IPicture_Get_Attributes);

   type af_IPicture_SetHdc is access function (
      This : access IPicture;
      hdc : OLE_HANDLE
      ) return HRESULT;

   pragma Convention(StdCall, af_IPicture_SetHdc);

   type IPicture is record
      lpVtbl : Pointer_To_IPictureVtbl;
   end record;
   pragma Convention(C_Pass_By_Copy, IPicture);

   type IPictureVtbl is record
      -- From Parent IUnknown
      QueryInterface : af_IPicture_QueryInterface;
      -- From Parent IUnknown
      AddRef : af_IPicture_AddRef;
      -- From Parent IUnknown
      Release : af_IPicture_Release;
      Get_Handle : af_IPicture_Get_Handle;
      Get_hPal : af_IPicture_Get_hPal;
      Get_Type : af_IPicture_Get_Type;
      Get_Width : af_IPicture_Get_Width;
      Get_Height : af_IPicture_Get_Height;
      Render : af_IPicture_Render;
      Put_hPal : af_IPicture_Put_hPal;
      Get_CurDC : af_IPicture_Get_CurDC;
      SelectPicture : af_IPicture_SelectPicture;
      Get_KeepOriginalFormat : af_IPicture_Get_KeepOriginalFormat;
      Put_KeepOriginalFormat : af_IPicture_Put_KeepOriginalFormat;
      PictureChanged : af_IPicture_PictureChanged;
      SaveAsFile : af_IPicture_SaveAsFile;
      Get_Attributes : af_IPicture_Get_Attributes;
      SetHdc : af_IPicture_SetHdc;
   end record;
   pragma Convention(C_Pass_By_Copy, IPictureVtbl);

   -- Element Name             : Picture
   -- Element Kind             : Dispatch
   subtype Picture is IDispatch;

   -- Element Name             : IPictureDisp
   -- Element Kind             : Alias
   subtype IPictureDisp is Picture;

   -- Element Name             : StdPicture
   -- Element Kind             : CoClass
   -- {0BE35204-8F91-11CE-9DE3-00AA004BB851}
   CLSID_StdPicture : aliased Stdole.GUID := ( 199447044 , 36753 , 4558 ,
      (unsigned_char'Val( 157),unsigned_char'Val( 227),unsigned_char'Val( 0),
       unsigned_char'Val( 170),unsigned_char'Val( 0),unsigned_char'Val( 75),
       unsigned_char'Val( 184),unsigned_char'Val( 81)));

   -- Element Name             : LoadPictureConstants
   -- Element Kind             : Enumeration
   type LoadPictureConstants is new Interfaces.C.long;

   Default : constant := 0;
   Monochrome : constant := 1;
   VgaColor : constant := 2;
   Color : constant := 4;

   -- Element Name             : StdFunctions
   -- Element Documentation    : Functions for Standard OLE Objects
   -- Element Kind             : Module
   package StdFunctions is
         type LoadPicture_scode_Pointer is access all IPictureDisp;
      function LoadPicture
          (
         filename : Win32.OleAuto.VARIANT;
         widthDesired : Interfaces.C.int;
         heightDesired : Interfaces.C.int;
         flags : LoadPictureConstants;
         retval : access LoadPicture_scode_Pointer
         ) return HRESULT;
      -- Loads a picture from a file

      pragma Import(StdCall, LoadPicture,"LoadPicture");

      function SavePicture
          (
         Picture : access IPictureDisp;
         filename : Win32.OleAuto.BSTR
         ) return HRESULT;
      -- Saves a picture to a file

      pragma Import(StdCall, SavePicture,"SavePicture");

   end StdFunctions;

   -- Element Name             : FontEvents
   -- Element Documentation    : Event interface for the Font object
   -- Element Kind             : Dispatch
   subtype FontEvents is IDispatch;

   -- Element Name             : IFontEventsDisp
   -- Element Kind             : Alias
   subtype IFontEventsDisp is FontEvents;

end stdole;
