-- Library Name             : BeepLibrary
-- Library Documentation    : Beep Type Library
-- Library Version          : 1.0
-- Library LIBID            : {0FE0EE20-8AA2-11D2-81AA-444553540001}
-- Elements in Type Library :  4

with Interfaces.C; use Interfaces.C;
with AdaWin;
with AdaCom;
with AdaCom.Interface;
with AdaCom.Dispinterface;
with AdaCom.Errors;
with Ada.Unchecked_Conversion;
with AdaCom.Variant;

package beep is

   -- {0FE0EE20-8AA2-11D2-81AA-444553540001}
   LIBID_BeepLibrary : aliased AdaWin.GUID := 
     Adacom.To_GUID("{0FE0EE20-8AA2-11D2-81AA-444553540001}");

   type IBeep;
   type IBeepVtbl;
   type GUID;
   type IMessage;
   type IMessageVtbl;
   type IStat;
   type IStatVtbl;
   type Pointer_To_IBeep is access all IBeep;
   type Pointer_To_IBeepVtbl is access all IBeepVtbl;
   type Pointer_To_GUID is access all GUID;
   type Pointer_To_AdaWin_Pointer_To_Void is access all AdaWin.Pointer_To_Void;
   type Pointer_To_IMessage is access all IMessage;
   type Pointer_To_IMessageVtbl is access all IMessageVtbl;
   type Pointer_To_IStat is access all IStat;
   type Pointer_To_IStatVtbl is access all IStatVtbl;
   type Pointer_To_Interfaces_C_int is access all Interfaces.C.int;
   type GUID_Data4_Array is 
     array (Integer range  0 .. 7) of Interfaces.C.unsigned_char;
   -- Element Name             : GUID
   -- Element Kind             : Record
   type GUID is
      record
         Data1 : Interfaces.C.unsigned_long;
         Data2 : Interfaces.C.unsigned_short;
         Data3 : Interfaces.C.unsigned_short;
         Data4 : GUID_Data4_Array;
      end record;
   -- Element Name             : IBeep
   -- Element Documentation    : Beep Interface
   -- Element Kind             : Interface
   -- {0FE0EE22-8AA2-11D2-81AA-444553540001}
   IID_IBeep
    : aliased AdaWin.GUID := 
     Adacom.To_GUID("{0FE0EE22-8AA2-11D2-81AA-444553540001}");

   type IBeep_Type is
     new AdaCom.Interface.Interface_Type with null record;

   procedure Initialize (This : in out IBeep_Type);
   function Pointer (This : in IBeep_Type)
     return Pointer_To_IBeep;

   type af_IBeep_QueryInterface is access function (
      This : access IBeep;
      riid : Pointer_To_GUID;
      ppvObj : Pointer_To_AdaWin_Pointer_To_Void) return AdaWin.HRESULT;

   pragma Convention(StdCall, af_IBeep_QueryInterface);
   type af_IBeep_AddRef is access function (
      This : access IBeep) return Interfaces.C.unsigned_long;

   pragma Convention(StdCall, af_IBeep_AddRef);
   type af_IBeep_Release is access function (
      This : access IBeep) return Interfaces.C.unsigned_long;

   pragma Convention(StdCall, af_IBeep_Release);
   type af_IBeep_Beep is access function (
      This : access IBeep) return AdaWin.HRESULT;
   -- Make a beep

   pragma Convention(StdCall, af_IBeep_Beep);

   procedure Beep
     (This : IBeep_Type);

   type IBeep is
      record
         lpVtbl : Pointer_To_IBeepVtbl;
      end record;
   pragma Convention(C_Pass_By_Copy, IBeep);

   type IBeepVtbl is
      record
         QueryInterface : af_IBeep_QueryInterface;
         AddRef : af_IBeep_AddRef;
         Release : af_IBeep_Release;
         Beep : af_IBeep_Beep;
      end record;
   pragma Convention(C_Pass_By_Copy, IBeepVtbl);

   function To_IBeep is
     new Ada.Unchecked_Conversion
     (AdaWin.Pointer_To_Void, Pointer_To_IBeep);

   function To_IBeep is
     new Ada.Unchecked_Conversion
     (AdaWin.Pointer_To_IUnknown, Pointer_To_IBeep);

   CLSID_BeepClass : aliased AdaWin.GUID := 
     Adacom.To_GUID("{0FE0EE21-8AA2-11D2-81AA-444553540001}");

   -- Element Name             : IMessage
   -- Element Documentation    : Message Interface
   -- Element Kind             : Interface
   -- {0FE0EE23-8AA2-11D2-81AA-444553540001}
   IID_IMessage
    : aliased AdaWin.GUID := 
     Adacom.To_GUID("{0FE0EE23-8AA2-11D2-81AA-444553540001}");

   type IMessage_Type is
     new AdaCom.Interface.Interface_Type with null record;

   procedure Initialize (This : in out IMessage_Type);
   function Pointer (This : in IMessage_Type)
     return Pointer_To_IMessage;

   type af_IMessage_QueryInterface is access function (
      This : access IMessage;
      riid : Pointer_To_GUID;
      ppvObj : Pointer_To_AdaWin_Pointer_To_Void) return AdaWin.HRESULT;

   pragma Convention(StdCall, af_IMessage_QueryInterface);
   type af_IMessage_AddRef is access function (
      This : access IMessage) return Interfaces.C.unsigned_long;

   pragma Convention(StdCall, af_IMessage_AddRef);
   type af_IMessage_Release is access function (
      This : access IMessage) return Interfaces.C.unsigned_long;

   pragma Convention(StdCall, af_IMessage_Release);
   type af_IMessage_Display is access function (
      This : access IMessage;
      message : AdaWin.BSTR) return AdaWin.HRESULT;
   -- Display a Message

   pragma Convention(StdCall, af_IMessage_Display);

   procedure Display
     (This : IMessage_Type;
      message : AdaWin.BSTR);

   type IMessage is
      record
         lpVtbl : Pointer_To_IMessageVtbl;
      end record;
   pragma Convention(C_Pass_By_Copy, IMessage);

   type IMessageVtbl is
      record
         QueryInterface : af_IMessage_QueryInterface;
         AddRef : af_IMessage_AddRef;
         Release : af_IMessage_Release;
         Display : af_IMessage_Display;
      end record;
   pragma Convention(C_Pass_By_Copy, IMessageVtbl);

   function To_IMessage is
     new Ada.Unchecked_Conversion
     (AdaWin.Pointer_To_Void, Pointer_To_IMessage);

   function To_IMessage is
     new Ada.Unchecked_Conversion
     (AdaWin.Pointer_To_IUnknown, Pointer_To_IMessage);

   -- Element Name             : IStat
   -- Element Documentation    : Stat Interface
   -- Element Kind             : Interface
   -- {0FE0EE24-8AA2-11D2-81AA-444553540001}
   IID_IStat
    : aliased AdaWin.GUID := 
     Adacom.To_GUID("{0FE0EE24-8AA2-11D2-81AA-444553540001}");

   type IStat_Type is
     new AdaCom.Interface.Interface_Type with null record;

   procedure Initialize (This : in out IStat_Type);
   function Pointer (This : in IStat_Type)
     return Pointer_To_IStat;

   type af_IStat_QueryInterface is access function (
      This : access IStat;
      riid : Pointer_To_GUID;
      ppvObj : Pointer_To_AdaWin_Pointer_To_Void) return AdaWin.HRESULT;

   pragma Convention(StdCall, af_IStat_QueryInterface);
   type af_IStat_AddRef is access function (
      This : access IStat) return Interfaces.C.unsigned_long;

   pragma Convention(StdCall, af_IStat_AddRef);
   type af_IStat_Release is access function (
      This : access IStat) return Interfaces.C.unsigned_long;

   pragma Convention(StdCall, af_IStat_Release);
   type af_IStat_Beeps is access function (
      This : access IStat;
      calls : Pointer_To_Interfaces_C_int) return AdaWin.HRESULT;
   -- Return number of times beep was called

   pragma Convention(StdCall, af_IStat_Beeps);

   procedure Beeps
     (This : IStat_Type;
      calls : Pointer_To_Interfaces_C_int);

   type IStat is
      record
         lpVtbl : Pointer_To_IStatVtbl;
      end record;
   pragma Convention(C_Pass_By_Copy, IStat);

   type IStatVtbl is
      record
         QueryInterface : af_IStat_QueryInterface;
         AddRef : af_IStat_AddRef;
         Release : af_IStat_Release;
         Beeps : af_IStat_Beeps;
      end record;
   pragma Convention(C_Pass_By_Copy, IStatVtbl);

   function To_IStat is
     new Ada.Unchecked_Conversion
     (AdaWin.Pointer_To_Void, Pointer_To_IStat);

   function To_IStat is
     new Ada.Unchecked_Conversion
     (AdaWin.Pointer_To_IUnknown, Pointer_To_IStat);

end beep;
