with Ada.Text_IO; use Ada.Text_IO;
with Interfaces.C;
with System;

with Adawin;

with AdaCom.Interface; use AdaCom.Interface;
with AdaCom.Errors; use AdaCom.Errors;
with AdaCOM.BSTR; use AdaCOM.BSTR;

with Beep; use Beep;


procedure Client is

   IBeep          : IBeep_Type;
   IMessage       : IMessage_Type;
   IStat          : IStat_Type;
   Message_String : Adawin.BSTR := To_BSTR(String'("Hello World!"));
   Message2       : Adawin.BSTR := To_BSTR(String'("Another Message"));
   Stat           : aliased Interfaces.C.Int;
begin
   Put_Line("Create COM Object");
   Create(IBeep, Beep.CLSID_BeepClass);

   Put_Line("Retrieve pointers to other interfaces in object");
   Create(IMessage, IBeep);
   Create(IStat, IBeep);

   Put_Line("IBeep::Beep");
   Beep.Beep(IBeep);

   Put_Line("IMessage::Display");
   Display(IMessage, Message_String);

   Put_Line("IMessage::Display");
   Display(IMessage, Message2);

   Put_Line("IStat::Beeps");
   Beeps(IStat, Stat'Unchecked_Access);

   Put_Line(Interfaces.C.Int'Image(Stat) &
            " messages were displayed.");

   Put_Line("Clean up BSTRs");
   Free(Message_String);
   Free(Message2);
end Client;




